#include <cassert>
#include <iostream>
#include <string>
using namespace std;

class Object {
	public:
	virtual ~Object() = 0;
};

Object::~Object(){}

class Vartotojas : public Object {
	string login;
	public:
	Vartotojas (string val) : login(val) { cout << "Vartotojas()\n";}
	string getLogin() {return login;}
	~Vartotojas() {cout << "~Vartotojas()\n";}
};


class ObjectStack {
	static const int size = 10;
	Object* stack[size];
	int top; //top rodo i sekanti laisva elementa
	public:
	ObjectStack() : top(0) {}
	void push(Object* el) {
		if (top > size) throw out_of_range("Stack Full! top > SIZE\n");
		stack[top++] = el;
	} 
	Object* pop() {
		if (top < 0) throw out_of_range("Stack is empty! top < 0\n");
		return stack[--top];
	}
	~ObjectStack() { // destruktorius atlaisvina atminti likusiems elementams
		while(top > 0) {
			delete pop();
			cout << "~ObjectStack() :" << top << endl;
		}
	}

	class iterator;
	friend class iterator;
	class iterator {
		ObjectStack& ss; //nuoroda i konteineri
		int index;
		public: 
		iterator(ObjectStack &x) : ss(x), index(0) {}
		iterator(ObjectStack &x, bool) : ss(x), index(ss.top) {} // constructor that creates iterator showing to the end of container		
		Object* operator++(int) {	//postfix increment
			if (index > ss.top) throw out_of_range("Iterator Class error! index > ss.top\n");
			return ss.stack[index++];
		} 
		bool operator!=(const iterator& r_op) const {
			return (index != r_op.index);
		}
		Object* current() const {
			return ss.stack[index];
		}
	};
	iterator begin() {return iterator(*this); }
	iterator end() {return iterator(*this,true); }	

};


int main() {
	try {
	ObjectStack stack;

	Vartotojas* v;
	for (int i = 0; i < 5; i++) {
		v = new Vartotojas("login");
		stack.push(v);
	}

	ObjectStack::iterator it = stack.begin();
	while(it != stack.end() ) {
		cout << ((Vartotojas*)it++)->getLogin() << endl;
	}	
	}
	catch(exception &e) {
		cout << "Caught: " << e.what() << endl;
		system("PAUSE");
	};
  system("PAUSE");
  return 0;
}
